# Revision 1.1 2007/04/21 19:50:00 iisaka
# initial release

import os, sys
from optparse import *
import scatter.util

class Application:
    def __init__(self, argv=None):
        if not argv:
            argv = sys.argv
	# self.args = []
	# self.options = []
	# self.caller_agrs = argv[1:]
	self.prog = os.path.basename(argv[0])
        self.prog_author = 'Gouichi Iisaka <iisaka51@hotmail.com>'
        self.prog_version = 0

        self.attrs = scatter.util.Struct()
        self.default_option += [
            Option("--debug", action="store_true",
		    dest="do_debug",
		    help=SUPPRESS_HELP),
            Option("-v", "--verbose", action="store_true",
		    dest="do_verbose",
		    help="verbose output"),
            Option("-V", "--version", action="store_true",
		    dest="do_version",
		    help="show version and exit"),
	    ]
        self.parser = OptionParser(option_list=self.default_option)
        try:
            self.parser.set_usage(self.usage_msg)
        except:
            self.parser.set_usage('Usage: %prog [options]')
	self.parseArgs()


	# Unset our locate
        try:
            del os.environ['LANG']
            del os.environ['LC_TIME']
	except KeyError:
	    pass
	
	if self.options.do_debug:
	    self.option_dump()

	if self.options.do_version:
	    self.usageHeader()
	    sys.exit(0)

    def run(self):
        sys.exit(-1)

    def usageHeader(self):
	return ''

    def usageTail(self):
	return ''

    def usage(self):
	self.usageHeader()
	self.parser.print_help()
	self.usageTail()

    def add_option(self, list):
	self.parser.add_option(list)

    def parseArgs(self):
	(self.options, self.args) = self.parser.parse_args()

    def option_dump(self):
	print self.options
	print
